From ef80dcc334c1e502efe3bbac1b8fbe8af44fd6b4 Mon Sep 17 00:00:00 2001
From: Andrey Vusik <night@etersoft.ru>
Date: Fri, 12 Mar 2010 18:21:51 +0300
Subject: [PATCH] Add ping.exe

---
 programs/ping/Makefile.in |   15 ++++
 programs/ping/ping.c      |  195 +++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 210 insertions(+), 0 deletions(-)
 create mode 100644 programs/ping/Makefile.in
 create mode 100644 programs/ping/ping.c

diff --git a/programs/ping/Makefile.in b/programs/ping/Makefile.in
new file mode 100644
index 0000000..cf246e5
--- /dev/null
+++ b/programs/ping/Makefile.in
@@ -0,0 +1,15 @@
+EXTRADEFS = -DWINE_NO_UNICODE_MACROS
+TOPSRCDIR = @top_srcdir@
+TOPOBJDIR = ../..
+SRCDIR    = @srcdir@
+VPATH     = @srcdir@
+MODULE    = ping.exe
+APPMODE   = -mconsole
+IMPORTS   = advapi32 wsock32 kernel32
+DELAYIMPORTS = user32
+
+C_SRCS = ping.c
+
+@MAKE_PROG_RULES@
+
+@DEPENDENCIES@  # everything below this line is overwritten by make depend
diff --git a/programs/ping/ping.c b/programs/ping/ping.c
new file mode 100644
index 0000000..0bfb280
--- /dev/null
+++ b/programs/ping/ping.c
@@ -0,0 +1,195 @@
+//
+// Ping.c -- Simple ping program using the proprietary Microsoft ICMP API
+// Author: Andrey Vusik
+//
+
+#include <windows.h>
+#include <winsock.h>
+#include <string.h>
+#include <stdio.h>
+#include <wine/unicode.h>
+#include <stdlib.h>
+
+
+typedef struct tagIPINFO
+{
+        u_char Ttl;
+        u_char Tos;
+        u_char IPFlags;
+        u_char OptSize;
+        u_char FAR *Options;
+}IPINFO, *PIPINFO;
+
+typedef struct tagICMPECHO
+{
+        u_long Source;
+        u_long Status;
+        u_long RTTime;
+        u_short DataSize;
+        u_short Reserved;
+        void FAR *pData; 
+        IPINFO  ipInfo;
+}ICMPECHO, *PICMPECHO;
+
+
+HANDLE (WINAPI *pIcmpCreateFile)(VOID);
+BOOL (WINAPI *pIcmpCloseHandle)(HANDLE);
+DWORD (WINAPI *pIcmpSendEcho)
+        (HANDLE,DWORD,LPVOID,WORD,PIPINFO,LPVOID,DWORD,DWORD);
+
+
+WCHAR* GetWideString(const char* strA)
+ {
+      WCHAR* strW = NULL;
+      int len = MultiByteToWideChar(CP_ACP, 0, strA, -1, NULL, 0); 
+      strW = HeapAlloc(GetProcessHeap(), 0, len * sizeof(WCHAR));
+   // CHECK_ENOUGH_MEMORY(strW);
+      MultiByteToWideChar(CP_ACP, 0, strA, -1, strW, len);
+      return strW;
+ }
+
+
+static int ping_printfW(const WCHAR *msg, ...)
+{
+    va_list va_args;
+    int wlen;
+    DWORD count, ret;
+    WCHAR msg_buffer[8192];
+    va_start(va_args, msg);
+    vsprintfW(msg_buffer, msg, va_args);
+    va_end(va_args);
+    wlen = lstrlenW(msg_buffer);
+    ret = WriteConsoleW(GetStdHandle(STD_OUTPUT_HANDLE), msg_buffer, wlen, &count, NULL);
+    if (!ret)
+    {
+       DWORD len;
+       char  *msgA;
+       len = WideCharToMultiByte(GetConsoleOutputCP(), 0, msg_buffer, wlen,
+             NULL, 0, NULL, NULL);
+       msgA = HeapAlloc(GetProcessHeap(), 0, len * sizeof(char));
+       if (!msgA)
+         return 0;
+       WideCharToMultiByte(GetConsoleOutputCP(), 0, msg_buffer, wlen, msgA, len,
+             NULL, NULL);
+       WriteFile(GetStdHandle(STD_OUTPUT_HANDLE), msgA, len, &count, FALSE);
+       HeapFree(GetProcessHeap(), 0, msgA);
+    }
+    return count;
+}
+
+
+void main(int argc, char **argv)
+{
+        WSADATA wsaData;
+        ICMPECHO icmpEcho;
+        HANDLE hndlIcmp;
+        HANDLE hndlFile;
+        LPHOSTENT pHost;
+        struct in_addr iaDest;
+        DWORD *dwAddress;
+        IPINFO ipInfo;
+        int nRet;
+        DWORD dwRet;
+        int x;
+        if (argc != 2)
+        {
+             static const WCHAR ping_host[] = {'\n','S','y','n','t','a','x',':',' ','p','i','n','g',' ','H','o','s','t','N','a','m','e','O','r','I','P','A','d','d','r','e','s','s','\n',0};
+             ping_printfW(ping_host);
+             return;
+        }
+        hndlIcmp = LoadLibraryA("ICMP.DLL");
+        if (hndlIcmp == NULL)
+        {
+                static const WCHAR no_ICMP[] = {'\n','C','o','u','l','d',' ','n','o','t',' ','l','o','a','d',' ','I','C','M','P','.','D','L','L','\n',0};
+                ping_printfW(no_ICMP);
+                return;
+        }
+
+        pIcmpCreateFile = (HANDLE (WINAPI *)(void))
+                GetProcAddress(hndlIcmp,"IcmpCreateFile");
+        pIcmpCloseHandle = (BOOL (WINAPI *)(HANDLE))
+                GetProcAddress(hndlIcmp,"IcmpCloseHandle");
+        pIcmpSendEcho = (DWORD (WINAPI *)
+                (HANDLE,DWORD,LPVOID,WORD,PIPINFO,LPVOID,DWORD,DWORD))
+                GetProcAddress(hndlIcmp,"IcmpSendEcho");
+
+        if (pIcmpCreateFile == NULL             ||
+                pIcmpCloseHandle == NULL        ||
+                pIcmpSendEcho == NULL)
+        {
+                static const WCHAR no_adress[] = {'\n','E','r','r','o','r',' ','g','e','t','t','i','n','g',' ','I','C','M','P',' ','p','r','o','c',' ','a','d','d','r','e','s','s','\n',0};
+                ping_printfW(no_adress);
+                FreeLibrary(hndlIcmp);
+                return;
+        }
+        nRet = WSAStartup(0x0101, &wsaData );
+    if (nRet)
+    {
+        static const WCHAR WSAStartup_error[] = {'\n','W','S','A','S','t','a','r','t','u','p','(',')',' ','e','r','r','o','r',':',' ','%','d','\n',0};
+        ping_printfW(WSAStartup_error, nRet);
+        WSACleanup();
+                FreeLibrary(hndlIcmp);
+        return;
+    }
+    if (0x0101 != wsaData.wVersion)
+    {
+        static const WCHAR err_version_WinSock[] = {'\n','W','i','n','S','o','c','k',' ','v','e','r','s','i','o','n',' ','1','.','1',' ','n','o','t',' ','s','u','p','p','o','r','t','e','d','\n',0};
+        ping_printfW(err_version_WinSock);
+        WSACleanup();
+                FreeLibrary(hndlIcmp);
+        return;
+    }
+    iaDest.s_addr = inet_addr(argv[1]);
+    if (iaDest.s_addr == INADDR_NONE)
+        pHost = gethostbyname(argv[1]);
+    else
+        pHost = gethostbyaddr((const char *)&iaDest, 
+                        sizeof(struct in_addr), AF_INET);
+        if (pHost == NULL)
+        {
+                static const WCHAR host_not_found[] = {'\n','%','s',' ','n','o','t',' ','f','o','u','n','d','\n',0};
+                ping_printfW(host_not_found, GetWideString(argv[1]));
+        WSACleanup();
+                FreeLibrary(hndlIcmp);
+                return;
+        }
+        static const WCHAR pinging_host[] = {'\n','P','i','n','g','i','n','g',' ','%','s',' ','[','%','s',']',0};
+        ping_printfW(pinging_host, GetWideString(pHost->h_name),
+                        GetWideString(inet_ntoa((*(LPIN_ADDR)pHost->h_addr_list[0]))));
+        dwAddress = (DWORD *)(*pHost->h_addr_list);
+        hndlFile = pIcmpCreateFile();
+        for (x = 0; x < 4; x++)
+        {
+                ipInfo.Ttl = 255;
+                ipInfo.Tos = 0;
+                ipInfo.IPFlags = 0;
+                ipInfo.OptSize = 0;
+                ipInfo.Options = NULL;
+                dwRet = pIcmpSendEcho(
+                        hndlFile,
+                       *dwAddress,
+                        NULL,
+                        0,
+                        &ipInfo,
+                        &icmpEcho,
+                        sizeof(struct tagICMPECHO),
+                        5000);
+                static const WCHAR reply_from[] = {'\n','R','e','p','l','y',' ','f','r','o','m',' ','%','s',' ',' ','T','i','m','e','=','%','l','d','m','s',' ',' ','T','T','L','=','%','d',0};
+                iaDest.s_addr = icmpEcho.Source;
+                ping_printfW(reply_from,
+                        GetWideString(inet_ntoa(iaDest)),
+                        icmpEcho.RTTime,
+                        icmpEcho.ipInfo.Ttl);
+                if (icmpEcho.Status)
+                {
+                        static const WCHAR echo_status[] = {'\n','E','r','r','o','r',':',' ','i','c','m','p','E','c','h','o','.','S','t','a','t','u','s','=','%','l','d',0};
+                        ping_printfW(echo_status, icmpEcho.Status);
+                        break;
+                }
+        }
+        static const WCHAR ent[] = {'\n',0};
+        ping_printfW(ent);
+        pIcmpCloseHandle(hndlFile);
+        FreeLibrary(hndlIcmp);
+        WSACleanup();
+}
-- 
1.6.5.8

